#include <konkret/konkret.h>
#include "Linux_AccountManagementCapabilities.h"

#include <stdbool.h>

#include "globals.h"

#define NAME LAMCNAME

static const CMPIBroker* _cb = NULL;

static void Linux_AccountManagementCapabilitiesInitialize()
{
}

static CMPIStatus Linux_AccountManagementCapabilitiesCleanup(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementCapabilitiesEnumInstanceNames(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus Linux_AccountManagementCapabilitiesEnumInstances(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    Linux_AccountManagementCapabilities lamc;

    Linux_AccountManagementCapabilities_Init(&lamc, _cb, KNameSpace(cop));
    Linux_AccountManagementCapabilities_Set_ElementNameEditSupported(
      &lamc, false);
    Linux_AccountManagementCapabilities_Set_InstanceID(&lamc, ORGID":"LAMCNAME);
    Linux_AccountManagementCapabilities_Set_ElementName(&lamc, NAME);

    Linux_AccountManagementCapabilities_Init_OperationsSupported(&lamc, 3);
    Linux_AccountManagementCapabilities_Set_OperationsSupported(&lamc, 0,
      Linux_AccountManagementCapabilities_OperationsSupported_Create);
    Linux_AccountManagementCapabilities_Set_OperationsSupported(&lamc, 1,
      Linux_AccountManagementCapabilities_OperationsSupported_Modify);
    Linux_AccountManagementCapabilities_Set_OperationsSupported(&lamc, 2,
      Linux_AccountManagementCapabilities_OperationsSupported_Delete);

    Linux_AccountManagementCapabilities_Init_SupportedUserPasswordEncryptionAlgorithms(&lamc, 1);
    Linux_AccountManagementCapabilities_Set_SupportedUserPasswordEncryptionAlgorithms(&lamc, 0, Linux_AccountManagementCapabilities_SupportedUserPasswordEncryptionAlgorithms_Other);

    KReturnInstance(cr, lamc);
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementCapabilitiesGetInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus Linux_AccountManagementCapabilitiesCreateInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementCapabilitiesModifyInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci,
    const char** properties)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementCapabilitiesDeleteInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementCapabilitiesExecQuery(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* lang,
    const char* query)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

CMInstanceMIStub(
    Linux_AccountManagementCapabilities,
    Linux_AccountManagementCapabilities,
    _cb,
    Linux_AccountManagementCapabilitiesInitialize())

static CMPIStatus Linux_AccountManagementCapabilitiesMethodCleanup(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementCapabilitiesInvokeMethod(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* meth,
    const CMPIArgs* in,
    CMPIArgs* out)
{
    return Linux_AccountManagementCapabilities_DispatchMethod(
        _cb, mi, cc, cr, cop, meth, in, out);
}

CMMethodMIStub(
    Linux_AccountManagementCapabilities,
    Linux_AccountManagementCapabilities,
    _cb,
    Linux_AccountManagementCapabilitiesInitialize())

KONKRET_REGISTRATION(
    "root/cimv2",
    "Linux_AccountManagementCapabilities",
    "Linux_AccountManagementCapabilities",
    "instance method");
